library(RCircos)
 
### res is table of all mQTLs

### identify transcisTrans<-rep("cis", nrow(res))
cisTrans[which(res$CHR.1 != res$CHR | abs(res$BP - res$MAPINFO) > 500000)]<-"trans"


### set up plot

data(UCSC.HG19.Human.CytoBandIdeogram)
head(UCSC.HG19.Human.CytoBandIdeogram)

chr.exclude <- c("chrX", "chrY")
cyto.info <- UCSC.HG19.Human.CytoBandIdeogram;
tracks.inside <- 10;
tracks.outside <- 0;
RCircos.Set.Core.Components(cyto.info, chr.exclude,tracks.inside, tracks.outside);

rcircos.params <- RCircos.Get.Plot.Parameters();
rcircos.cyto <- RCircos.Get.Plot.Ideogram();
rcircos.position <- RCircos.Get.Plot.Positions();

#out.file <- "RCircosDemoHumanGenome.pdf";
#pdf(file=out.file, height=8, width=8, compress=TRUE);
RCircos.Set.Plot.Area();

#par(mai=c(0.25, 0.25, 0.25, 0.25));
#plot.new();
#plot.window(c(-2.5,2.5), c(-2.5, 2.5));
RCircos.Chromosome.Ideogram.Plot();

track.num <- 11;
RCircos.Link.Plot(RCircos.Link.Data, 0, FALSE);
data(RCircos.Ribbon.Data);
RCircos.Ribbon.Plot(ribbon.data=RCircos.Ribbon.Data, track.num=11, by.chromosome=FALSE, twist=FALSE);

tmp<-res[which(cisTrans == "trans"), c(2,3,3, 7,8,8)]
tmp[,1]<-paste("chr", tmp[,1], sep = "")
tmp[,4]<-paste("chr", tmp[,4], sep = "")

params <- RCircos.Get.Plot.Parameters();
params$text.size <- 2;
RCircos.Reset.Plot.Parameters(params)

out.file <- ;
pdf(file=out.file, height=12, width=12);
RCircos.Set.Plot.Area();

#par(mai=c(0.25, 0.25, 0.25, 0.25));
#plot.new();
#plot.window(c(-2.5,2.5), c(-2.5, 2.5));
RCircos.Cyto <- RCircos.Get.Plot.Ideogram()
    RCircos.Pos <- RCircos.Get.Plot.Positions()
    RCircos.Par <- RCircos.Get.Plot.Parameters()
    right.side <- nrow(RCircos.Pos)/2
    outer.location <- RCircos.Par$chr.ideog.pos + RCircos.Par$chrom.width
    inner.location <- RCircos.Par$chr.ideog.pos
    chroms <- unique(RCircos.Cyto$Chromosome)
    for (a.chr in 1:length(chroms)) {
        the.chr <- RCircos.Cyto[RCircos.Cyto$Chromosome == chroms[a.chr],
            ]
        start <- the.chr$Location[1] - the.chr$Unit[1] + 1
        end <- the.chr$Location[nrow(the.chr)]
        mid <- round((end - start + 1)/2, digits = 0) + start
        chr.color <- the.chr$ChrColor[nrow(the.chr)]
        pos.x <- c(RCircos.Pos[start:end, 1] * outer.location,
            RCircos.Pos[end:start, 1] * inner.location)
        pos.y <- c(RCircos.Pos[start:end, 2] * outer.location,
            RCircos.Pos[end:start, 2] * inner.location)
        polygon(pos.x, pos.y)
        chr.name <- sub(pattern = "chr", replacement = "", chroms[a.chr])
        text(RCircos.Pos[mid, 1] * RCircos.Par$chr.name.pos,
            RCircos.Pos[mid, 2] * RCircos.Par$chr.name.pos, label = chr.name,
            srt = RCircos.Pos$degree[mid], cex = 2)
        lines(RCircos.Pos[start:end, ] * RCircos.Par$highlight.pos,
            col = chr.color, lwd = RCircos.Par$highlight.width)
    }
    for (a.band in 1:nrow(RCircos.Cyto)) {
        a.color <- RCircos.Cyto$BandColor[a.band]
        if (a.color == "white") {
            next
        }
        start <- RCircos.Cyto$Location[a.band] - RCircos.Cyto$Unit[a.band] +
            1
        end <- RCircos.Cyto$Location[a.band]
        pos.x <- c(RCircos.Pos[start:end, 1] * outer.location,
            RCircos.Pos[end:start, 1] * inner.location)
        pos.y <- c(RCircos.Pos[start:end, 2] * outer.location,
            RCircos.Pos[end:start, 2] * inner.location)
        polygon(pos.x, pos.y, col = a.color, border = NA)
    }


### get colours of chromosome
RCircos.Cyto <- RCircos.Get.Plot.Ideogram()
ChrColMap<-unique(RCircos.Cyto[,c(1,7)])
LineCexMap<-cbind(seq(from = 0, to = 0.4, by = 0.01), seq(from = 0.5, to = 4, by = 0.0875))


#RCircos.Link.Plot(tmp, 1, FALSE);


   RCircos.Pos <- RCircos.Get.Plot.Positions()
    RCircos.Par <- RCircos.Get.Plot.Parameters()
    tmp <- RCircos.Validate.Genomic.Data(tmp, plot.type = "link")
    one.track <- RCircos.Par$track.height + RCircos.Par$track.padding
    start <- RCircos.Par$track.in.start - (1 - 1) * one.track
    base.positions <- RCircos.Pos * start
    data.points <- matrix(rep(0, nrow(tmp) * 2), ncol = 2)
    for (a.link in 1:nrow(tmp)) {
        data.points[a.link, 1] <- RCircos.Data.Point(tmp[a.link,
            1], tmp[a.link, 2])
        data.points[a.link, 2] <- RCircos.Data.Point(tmp[a.link,
            4], tmp[a.link, 5])
        if (data.points[a.link, 1] == 0 || data.points[a.link,
            2] == 0) {
            print("Error in chromosome locations ...")
            break
        }
    }
 #   link.colors <- RCircos.Get.Link.Colors(tmp, by.chromosome)
	link.colors<-ChrColMap[match(tmp[,4], ChrColMap[,1]),2]
	link.cex.line<-LineCexMap[match(round(abs(res$Fetal.beta[which(cisTrans == "trans")]), 2), LineCexMap[,1]),2]

    for (a.link in 1:nrow(data.points)) {
        point.one <- data.points[a.link, 1]
        point.two <- data.points[a.link, 2]
        if (point.one > point.two) {
            point.one <- data.points[a.link, 2]
            point.two <- data.points[a.link, 1]
        }
        P0 <- as.numeric(base.positions[point.one, ])
        P2 <- as.numeric(base.positions[point.two, ])
        links <- RCircos.Link.Line(P0, P2)
        lines(links$pos.x, links$pos.y, type = "l", col = link.colors[a.link], lwd = link.cex.line[a.link])
    }
