

### res is table of all bonferroni significant mQTLs with corresponding effects and p values in adult brain regions
library(gplots)


palette<-c(colorRampPalette(c("red", "lightgreen"))(168), colorRampPalette(c("skyblue", "blue", "navy"))(168))

ref.alleles<-res$BA9.Allele
ref.alleles[is.na(ref.alleles)]<-res$CER.Allele[is.na(ref.alleles)]
ref.alleles[is.na(ref.alleles)]<-res$STR.Allele[is.na(ref.alleles)]
ref.alleles[is.na(ref.alleles)]<-res$Fetal.Allele[is.na(ref.alleles)]

### check same allele tested
res$Fetal.beta[which(res$Fetal.Allele != ref.alleles)]<-res$Fetal.beta[which(res$Fetal.Allele != ref.alleles)]*-1
res$BA9.beta[which(res$BA9.Allele != ref.alleles)]<-res$BA9.beta[which(res$BA9.Allele != ref.alleles)]*-1
res$STR.beta[which(res$STR.Allele != ref.alleles)]<-res$STR.beta[which(res$STR.Allele != ref.alleles)]*-1
res$CER.beta[which(res$CER.Allele != ref.alleles)]<-res$CER.beta[which(res$CER.Allele != ref.alleles)]*-1

### only include QTLs tested in at least one additional region to the one it is significant in.

tmp<-apply(is.na(res[,c(4,7,10,13)]),1,sum)
plotData<-as.matrix(res[which(tmp < 2),c(13,4,10,7)]) ### this can be found in source Data

heatmap.2(plotData, trace = "none", scale = "none", 
col = palette, breaks = seq(from = -0.42, to = 0.42, by = 0.0025), labCol= c("Fetal", "PFC",  "STR","CER"), labRow = NA, density.info = "none", na.color = "white", Colv = FALSE, Rowv = TRUE)

