### 

## extract and merge methylation genotype data from each datasets for probe and SNP in question
## check genotype refers to same allele, if not flip.
## create genotype labels from genotype bim file
meth<-c(meth.pfc["cg21577356",],meth.str["cg21577356",],meth.cer["cg21577356",], meth.fetal["cg21577356",])
if(adult.alleles["rs2108854"] == fetal.alleles["rs2108854"]){
	geno<-c(geno.pfc["rs2108854",],geno.str["rs2108854",],geno.cer["rs2108854",], geno.fetal["rs2108854",])
	labs<-c(paste(bim_2[match("rs2108854", bim_2[,2]),6],bim_2[match("rs2108854", bim_2[,2]),6], sep = ""), paste(bim_2[match("rs2108854", bim_2[,2]),6],bim_2[match("rs2108854", bim_2[,2]),5], sep = ""),paste(bim_2[match("rs2108854", bim_2[,2]),5],bim_2[match("rs2108854", bim_2[,2]),5], sep = "")) 
} else {
	geno<-c(geno.pfc["rs2108854",],geno.str["rs2108854",],geno.cer["rs2108854",], (2-geno.fetal["rs2108854",]))
	labs<-c(paste(bim_2[match("rs2108854", bim_2[,2]),5],bim_2[match("rs2108854", bim_2[,2]),5], sep = ""), paste(bim_2[match("rs2108854", bim_2[,2]),5],bim_2[match("rs2108854", bim_2[,2]),6], sep = ""),paste(bim_2[match("rs2108854", bim_2[,2]),6],bim_2[match("rs2108854", bim_2[,2]),6], sep = "")) 	
}



br<-factor(br, levels = c("Fetal", "PFC", "STR", "CER"))

par(mar = c(8,8,10,2))
par(mgp = c(5,1.5,0))

boxplot(meth*100 ~ geno*br, col = c(rep("red", 3), rep("blue", 3), rep("green", 3), rep("orange", 3)), ylab = "% DNA Methylation", names = rep(labs, 4), cex.axis = 3, cex.lab = 3, axes = FALSE, cex.main = 3)
box()
axis(2, las = 2, cex.axis = 2.5, cex.lab = 2.5)
axis(1, rep(labs, 4), at = c(1:12), cex.lab = 1.8, cex.axis = 1.8)
title(main = paste("rs2108854", "cg21577356", sep = " - "), cex.main = 3, line = 6)
title(sub = paste("het P = ", signif(opp$hetP[i],3), sep = ""), adj = 1, line = 5, cex.sub = 3)
abline(v = 3.5, lty = 2)
abline(v = 6.5, lty = 2)
abline(v = 9.5, lty = 2)
mtext("Fetal", at = 2, cex = 3)
mtext("PFC", at = 5, cex = 3)
mtext("STR", at = 8, cex = 3)
mtext("CER", at = 11, cex = 3)


