
library(gplots)

### res is a table of all PGC2 index SNPs (and tag SNPs of these)

## set colour scale for heterogeneity p values
ld_palette<-cbind(seq(from = 0, to = 12, by = 0.01) , colorRampPalette(c("yellow", "darkgreen"))(1201))
ldMap<-ld_palette[match(signif(-log10(res$hetP),2), ld_palette[,1]),2]

heatmap.2(cbind(res$Fetal.beta, res$BA9.beta, res$STR.beta, res$CER.beta), trace = "none", scale = "none", Rowv = FALSE, Colv = FALSE, col = colorpanel(100, "red", "gray", "blue"), labRow = paste(res$SNP, res$Probe, sep = " - "), labCol = c("Fetal", "PFC", "STR", "CER"), density.info = "none", RowSideColors = ldMap, keysize = 1, margins = c(8,16), densadj = 0.18, cexCol = 2, cexRow = 1.32, rowsep = c(6,7,19,20,32,33,58), sepcolor = "black")
## plot legend for heterogeneity Pvalues
plot(seq(from = 0, to = 12, by = 0.01), rep(1, 1201), col = colorRampPalette(c("yellow", "darkgreen"))(1201), pch = 15, axes = FALSE, xlab = "-log10(heterogeneity P)", ylab = "", ylim = c(0.1,0.9))
segments(seq(from = 0, to = 12, by = 0.01), rep(0, 1201), seq(from = 0, to = 12, by = 0.01), rep(1, 1201),col = colorRampPalette(c("yellow", "darkgreen"))(1201))
axis(1)
