

### find snps and probes with a QTL in any dataset
snps.output<- ### All SNP positions
snps.output<-snps.output[order(snps.output[,1], snps.output[,2]),]
meth.output<- ### All probe positions
meth.output<-meth.output[order(meth.output$CHR, meth.output$MAPINFO),]


chrEnd.meth<-vector(length = 22)
chrEnd.snps<-vector(length = 22)
for(i in 1:22){
	chrEnd.meth[i]<-max(meth.output[which(meth.output$CHR == i),3])
	chrEnd.snps[i]<-max(snps.output[which(snps.output[,1] == i),2])
}

chrStart.meth<-vector(length = 22)
chrStart.snps<-vector(length = 22)
for(i in 1:22){
	chrStart.meth[i]<-min(meth.output[which(meth.output$CHR == i),3])
	chrStart.snps[i]<-min(snps.output[which(snps.output[,1] == i),2])
}

chrSize.snps<-chrEnd.snps-chrStart.snps
chrSize.meth<-chrEnd.meth-chrStart.meth

snp.coord<-vector(length = nrow(snps.output))
meth.coord<-vector(length = nrow(meth.output))
for(i in 1:22){
	snp.coord[which(snps.output[,1] == i)]<-(snps.output[which(snps.output[,1] == i),2]-chrStart.snps[i])/chrSize.snps[i]+i-1
	meth.coord[which(meth.output[,2] == i)]<-(meth.output[which(meth.output[,2] == i),3]-chrStart.meth[i])/chrSize.meth[i]+i-1
}


snps.output<-cbind(snps.output, snp.coord)
meth.output<-cbind(meth.output, meth.coord)

logP_col_palette<-cbind(seq(from = 0, to = 0.43, by = 0.01) , colorRampPalette(c("tan1", "orange",  "red", "red3", "red4",  "darkred"))(44))


layout(matrix(c(1,2), ncol = 1), height = c(1,0.2))
par(mar = c(6,6,6,6))
par(mgp = c(3.5,0.75,0))
points.y<-snps.output[match(paste(output$SNP_Chr, output$SNP_BP, sep = "|"), paste(snps.output[,1], snps.output[,2], sep = "|")),3]
points.x<-meth.output[match(output$gene, meth.output$TargetID),4]
logP<-abs(output$beta)
points.col<-logP_col_palette[match(round(logP,2), logP_col_palette[,1]),2]
plot(points.x, points.y, pch = 15, cex =0.5, col = points.col, type = "n", ylab = "Position of SNP (Chr)", xlab = "Position of DNA methylation site (Chr)", main = "",  axes = FALSE, xlim = c(0,22), ylim = c(0,22), xaxs = "i", yaxs = "i",cex.lab = 2.6, cex.axis = 2, cex.main = 2.5)
for(i in 1:22){
	abline(h = i, col = "lightblue")
	abline(v = i, col = "lightblue")
	}
box(col = "lightblue")
axis(1, at = seq(0.5,21.5, by = 1), c(1:22), tick = FALSE, cex.axis = 2.5)
axis(2, at = seq(0.5,21.5, by = 1), c(1:22), tick = FALSE, cex.axis = 2.5, las = 2)
points(points.x[length(points.x):1], points.y[length(points.x):1], pch = 15, cex =0.45, col = points.col[length(points.x):1])



par(mar = c(3,8,1.5,8))
par(mgp = c(3,1.7,0))
plot(as.numeric(logP_col_palette[,1]), rep(1, nrow(logP_col_palette)), col = logP_col_palette[,2], pch = 15, cex = 4, axes = FALSE, main  = "", ylab = "", ylim = c(0.9999,1.001),xlab = "", cex.lab = 2, cex.axis = 2, cex.main = 2.5, adj = 0)
axis(1, at = c(0,0.2,0.4,0.6),  c(0,0.2,0.4,0.6)*100, cex.axis = 2)

