

datas<-list(abs(res$Fetal.beta)[which(res$BA9.P <= 1e-4 | res$STR.P <= 1e-4 |res$CER.P <= 1e-4)]*100, abs(res$Fetal.beta)[which(res$BA9.P <= 1e-4)]*100, abs(res$Fetal.beta)[which(res$STR.P <= 1e-4)]*100, abs(res$Fetal.beta)[which(res$CER.P <= 1e-4)]*100, abs(res$Fetal.beta)[which(res$BA9.P > 1e-4 & res$STR.P > 1e-4 & res$CER.P > 1e-4)]*100, abs(res$Fetal.beta)[which(res$BA9.P > 1e-4)]*100, abs(res$Fetal.beta)[which(res$STR.P > 1e-4)]*100, abs(res$Fetal.beta)[which(res$CER.P > 1e-4)]*100)

cols<-rep(c("blue", "red", "forestgreen", "purple"),2) 

    n <- length(datas)
    at <- 1:n
    upper <- vector(mode = "numeric", length = n)
    lower <- vector(mode = "numeric", length = n)
    q1 <- vector(mode = "numeric", length = n)
    q3 <- vector(mode = "numeric", length = n)
    med <- vector(mode = "numeric", length = n)
    base <- vector(mode = "list", length = n)
    height <- vector(mode = "list", length = n)
    baserange <- c(Inf, -Inf)
    args <- list(display = "none")
	ylim<-c(0,40)
	add<-FALSE
	horizontal<-FALSE
	lty = 1
	border = "black"
	h<-NULL
	range<-1.5
	wex<-1
	lwd<-1
	drawRect<-TRUE
	rectCol = "black"
	colMed = "white"
	pchMed = 19
	 if (!(is.null(h)))
        args <- c(args, h = h)
    for (i in 1:n) {
        data <- datas[[i]]
        data.min <- min(data)
        data.max <- max(data)
        q1[i] <- quantile(data, 0.25)
        q3[i] <- quantile(data, 0.75)
        med[i] <- median(data)
        iqd <- q3[i] - q1[i]
        upper[i] <- min(q3[i] + range * iqd, data.max)
        lower[i] <- max(q1[i] - range * iqd, data.min)
        est.xlim <- c(min(lower[i], data.min), max(upper[i],
            data.max))
        smout <- do.call("sm.density", c(list(data, xlim = est.xlim),
            args))
        hscale <- 0.4/max(smout$estimate) * wex
        base[[i]] <- smout$eval.points
        height[[i]] <- smout$estimate * hscale
        t <- range(base[[i]])
        baserange[1] <- min(baserange[1], t[1])
        baserange[2] <- max(baserange[2], t[2])
    }
    if (!add) {
        xlim <- if (n == 1){
            at + c(-0.5, 0.5)
		}
        else range(at) + min(diff(at))/2 * c(-1, 1)
        if (is.null(ylim)) {
            ylim <- baserange
        }
    }
    label <-  rep("", n)
    boxwidth <- 0.05 * wex
    if (!add)
        plot.new()
    if (!horizontal) {
        if (!add) {
            plot.window(xlim = xlim, ylim = ylim)
			axis(2, seq(from = 0, to = 100, by = 5), las = 2)
			#axis(1, at = at, label = label)
        }
        box()
        for (i in 1:n) {
            polygon(c(at[i] - height[[i]], rev(at[i] + height[[i]])),
                c(base[[i]], rev(base[[i]])), col = cols[i], border = border,
                lty = lty, lwd = lwd)
            if (drawRect) {
                lines(at[c(i, i)], c(lower[i], upper[i]), lwd = lwd,
                  lty = lty)
                rect(at[i] - boxwidth/2, q1[i], at[i] + boxwidth/2,
                  q3[i], col = rectCol)
                points(at[i], med[i], pch = pchMed, col = colMed)
            }
        }
    } else {
        if (!add) {
            plot.window(xlim = ylim, ylim = xlim)
			axis(2, seq(from = 0, to = 100, by = 5), las = 2)
			axis(1, at = at, label = label)
        }
        box()
        for (i in 1:n) {
            polygon(c(base[[i]], rev(base[[i]])), c(at[i] - height[[i]],
                rev(at[i] + height[[i]])), col = cols[i], border = border,
                lty = lty, lwd = lwd)
            if (drawRect) {
                lines(c(lower[i], upper[i]), at[c(i, i)], lwd = lwd,
                  lty = lty)
                rect(q1[i], at[i] - boxwidth/2, q3[i], at[i] +
                  boxwidth/2, col = rectCol)
                points(med[i], at[i], pch = pchMed, col = colMed)
            }
        }
    }
    invisible(list(upper = upper, lower = lower, median = med,
        q1 = q1, q3 = q3))
title(ylab = "% DNA methylation change per allele")
abline(v = 4.5, lty = 2)
axis(1, rep(c("Fetal", "PFC", "STR", "CER"),2), at = 1:8)
axis(1, paste("n = ", unlist(lapply(datas, length)), sep = ""), at = 1:8, line = 1, tick = FALSE)
title(main = "Replicating mQTL", adj = 0, line = 0.5)
title(main = "Non-replicating mQTL", adj = 1, line = 0.5)
